<?php

namespace Dao;
use Conn\MySqlConnect;

/**
 * Description of Cidades
 *
 * @author Délio
 */
class Cidades {
    
    public $id;
    public $titulo;
    public $slug;
    public $data_cadastro;
    public $usuario_cadastrou;
    public $data_alteracao;
    public $usuario_alterou;
    public $status;

    function __construct($res = null) {
        $this->id = (int) 0;
        $this->titulo = (string) '';
        $this->slug = (string) '';
        $this->data_cadastro = (string) date('Y-m-d H:i:s');
        $this->usuario_cadastrou = (int) 0;
        $this->data_alteracao = (string) date('Y-m-d H:i:s');
        $this->usuario_alterou = (int) 0;
        $this->status = (string) 'A';
        $this->fill($res);
    }
    
    private function fill($res) {
        if ($res != null && $res instanceof \stdClass) {
            $this->id = (int) (isset($res->id) ? $res->id : 0);
            $this->titulo = (string) (isset($res->titulo) ? $res->titulo : '');
            $this->slug = (string) (isset($res->slug) ? $res->slug : '');
            $this->data_cadastro = (string) (isset($res->data_cadastro) ? $res->data_cadastro : null);
            $this->usuario_cadastrou = (int) (isset($res->usuario_cadastrou) ? $res->usuario_cadastrou : 0);
            $this->data_alteracao = (string) (isset($res->data_alteracao) ? $res->data_alteracao : null);
            $this->usuario_alterou = (int) (isset($res->usuario_alterou) ? $res->usuario_alterou : 0);
            $this->status = (string) (isset($res->status) ? $res->status : 'A');
        }
    }

    private function inserir(MySqlConnect $conecta) {
        $sql = $conecta->prepare("INSERT INTO cidades (titulo, slug, data_cadastro, usuario_cadastrou, status) VALUES (?, ?, ?, ?, ?)") or die($conecta->error);
        $sql->bind_param("sssis", $this->titulo, $this->slug, $this->data_cadastro, $this->usuario_cadastrou, $this->status);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Cidade inserida com sucesso!', 'id' => $sql->insert_id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => 0]);
    }
    
    private function editar(MySqlConnect $conecta) {
        $sql = $conecta->prepare("UPDATE cidades SET titulo = ?, slug = ?, data_alteracao = ?, usuario_alterou = ? WHERE id = ?") or die($conecta->error);
        $sql->bind_param("sssii", $this->titulo, $this->slug, $this->data_alteracao, $this->usuario_alterou, $this->id);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Cidade atualizada com sucesso!', 'id' => $this->id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => $this->id]);
    }
    
    function salvar(MySqlConnect $conecta) {
        if ($this->id == 0)
            return $this->inserir($conecta);
        return $this->editar($conecta);
    }
    
    function excluir(MySqlConnect $conecta) {
        $sql = $conecta->prepare("UPDATE cidades SET data_alteracao = ?, usuario_alterou = ?, status = ? WHERE id = ?") or die($conecta->error);
        $sql->bind_param("sisi", $this->data_alteracao, $this->usuario_alterou, $this->status, $this->id);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Cidade excluida com sucesso!', 'id' => $this->id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => $this->id]);
    }
    
    function getLista(MySqlConnect $conecta, $where = '') {
        $lst_cidades = [];
        $sql = $conecta->query("SELECT * FROM cidades WHERE status = 'A' $where") or die($conecta->error);
        while ($res = $sql->fetch_object())
            $lst_cidades[] = new Cidades($res);
        return $lst_cidades;
    }
    
    function getCidadePorId(MySqlConnect $conecta, $id) {
        $sql = $conecta->query("SELECT * FROM cidades WHERE id = '$id' AND status = 'A'") or die($conecta->error);
        if ($sql->num_rows > 0) {
            $res = $sql->fetch_object();
            $this->fill($res);
        }
    }
    
    function getCidadePorSlug(MySqlConnect $conecta, $slug) {
        $sql = $conecta->query("SELECT id FROM cidades WHERE slug = '$slug' AND status = 'A'") or die($conecta->error);
        if ($sql->num_rows > 0) {
            $res = $sql->fetch_object();
            $this->getCidadePorId($conecta, $res->id);
        }
    }
}